/////////////////////////////////////////////////////////////////////////////
// Spline.cpp : implementation file
//

#include "stdafx.h"
#include "DebugCalculation.h"
#include "Spline.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////

const double Pi = 3.14159265358979323846;
const double Pi2= Pi*2.;

/////////////////////////////////////////////////////////////////////////////
// Spline

Spline::Spline()
{
}

Spline::~Spline()
{
}
/////////////////////////////////////////////////////////////////////////////
//
//	     
//	http://www.srcc.msu.su/num_anal/
//
//	  Microsoft Visual C++     std::vector
//	  	byvshikh@mail.ru
//
//---------------------------------------------------------------------------

void Spline::iis3r(std::vector<double> *x,//  X  
				   std::vector<double> *y,//   Y   x
				   double *bpar,		   //  
				   std::vector<double> *c0,//    
				   std::vector<double> *c1,
				   std::vector<double> *c2)
{
//	       
//	         .

//	  *x=NULL,        X   1.

//	     ,     
//	     X

	static double equiv_0[1], equiv_1[1], equiv_2[1];
#define yppa (equiv_2)
#define yppb (equiv_0)
#define sixi (equiv_1)
#define dxjp1 (equiv_2)
	static double dyjp1;
#define pj (equiv_1)
	static double dx;
#define dxj (equiv_0)
	static double dyj, dxp;

	const double dLimit=1.e-10;
	long nxm1;
	long i,j,nx;

	bpar--;

	nx=y->size();

	nxm1=nx-1;
	c0->resize(nxm1);
	c1->resize(nxm1);
	c2->resize(nxm1);

	if (nx<2) { utii10(65,3); return; }

	if (nx!=2)
	{
		if (x) *dxj=(*x)[1]-(*x)[0];
		else   *dxj=1.;

		if (*dxj<0.){ utii10(66,3); return; }

		dyj=(*y)[1]-(*y)[0];

		for (j=2; j<=nxm1; ++j)
		{
			if (x) *dxjp1=(*x)[j]-(*x)[j-1];
			else   *dxjp1=1.;

			if (*dxjp1<0.) { utii10(66,3); return; }

			dyjp1=(*y)[j]-(*y)[j-1];
			dxp= *dxj+ *dxjp1;

			if(fabs(dxp)>dLimit)
			{
				(*c0)[j-1]= *dxjp1/dxp;
				if ((fabs(*dxjp1)>dLimit)&&(fabs(*dxj)>dLimit))
					 (*c2)[j-1]=6.*(dyjp1/ *dxjp1-dyj/ *dxj)/dxp;
				else (*c2)[j-1]=0.;
			}
			else
			{
				(*c0)[j-1]=0.;
				(*c2)[j-1]=0.;
			}
			(*c1)[j-1]=1.-(*c0)[j-1];

			*dxj= *dxjp1;
			dyj=dyjp1;
		}
	}

	(*c0)[0]=-bpar[1]*0.5;
	(*c1)[0]= bpar[2]*0.5;

	if (nx != 2)
	for (j=2; j<=nxm1; ++j)
	{
		*pj=(*c1)[j-1]*(*c0)[j-2]+2.;
//		if (fabs(*pj)>dLimit)
//		{
			(*c0)[j-1]=-(*c0)[j-1]/ *pj;
			(*c1)[j-1]=((*c2)[j-1]-(*c1)[j-1]*(*c1)[j-2])/ *pj;
//		}
//		else
//		{
//			(*c0)[j-1]=0.;
//			(*c1)[j-1]=0.;
//		}
	}

	*yppb=(bpar[4]-bpar[3]*(*c1)[nxm1-1])/(bpar[3]*(*c0)[nxm1-1]+2.);

	for (i=1; i<= nxm1; ++i)
	{
		j=nx-i;
		*yppa=(*c0)[j-1]* *yppb+(*c1)[j-1];

		if (x) dx=(*x)[j]-(*x)[j-1];
		else   dx=1.;

		(*c1)[j-1]= *yppa*0.5;
		if (fabs(dx)>dLimit)
		{
			(*c2)[j-1]=(*yppb - *yppa)/(6.*dx);
			(*c0)[j-1]=((*y)[j]-(*y)[j-1])/dx-((*c1)[j-1]+(*c2)[j-1]*dx)*dx;
		}
		else
		{
			(*c2)[j-1]=0.;
			(*c0)[j-1]=0.;
		}
		*yppb = *yppa;
	}
}

#undef dxj
#undef pj
#undef dxjp1
#undef sixi
#undef yb
#undef ya
//---------------------------------------------------------------------------

void Spline::iis4r(std::vector<double> *x,//  X  
				   std::vector<double> *y,//   Y   x
				   std::vector<double> *c0,//    
				   std::vector<double> *c1,
				   std::vector<double> *c2,
				   std::vector<double> *u,//  ,     
				   std::vector<double> *s)//     u
{
	//     ,   u
	//   *x=NULL,        X   1.

	double d,dd;
	int ierr, jer, ker;
	long j,k,nx,m,nxm1;
	long i = 1;

	nx=y->size();
	m=u->size();

	if (m<=0) return;
	s->resize(m);

	ierr =0;
	jer = 0;
	ker = 0;
	nxm1=nx-1;

	if (nx<2) { utii10(65,4); return; }

//	if (x) for (j=1; j<=nxm1; ++j) if ((*x)[j]-(*x)[j-1]<=0.) { utii10(66,4); return; }
	if (x) for (j=1; j<=nxm1; ++j) if ((*x)[j]-(*x)[j-1]<0.) { utii10(66,4); return; }

	if (i>nxm1) i=1;

	for (k=1; k<=m; k++)
	{
		if (x) d=(*u)[k-1]-(*x)[i-1];
		else   d=(*u)[k-1]-(i-1);

		if (d<0.)		goto L3;
		else if (d==0.) goto L7;
		else			goto L5;
L3:
		if (i==1) goto L8;

		i--;
		if (x) d=(*u)[k-1]-(*x)[i-1];
		else   d=(*u)[k-1]-(i-1);

		if (d<0.)		goto L3;
		else if (d==0.) goto L7;
		else			goto L6;
L4:
		i++;
		d=dd;
L5:
		if (i>=nx) goto L9;

		if (x) dd=(*u)[k-1]-(*x)[i];
		else   dd=(*u)[k-1]-i;

		if (dd>=0.) goto L4;
		if (d==0.)  goto L7;

L6:
		(*s)[k-1]=(((*c2)[i-1]*d+(*c1)[i-1])*d+(*c0)[i-1])*d+(*y)[i-1];
		goto L10;
L7:
		(*s)[k-1]=(*y)[i-1];
		goto L10;
L8:
		jer = 1;
		goto L6;
L9:
		if (dd>0.) ker = 2;

		if (x) d=(*u)[k-1]-(*x)[nxm1-1];
		else   d=(*u)[k-1]-(nxm1-1);

		i=nxm1;
		goto L6;
L10:;
	}
	ierr = __max(jer,ker);

	if (ierr) utii10(ierr, 4);
}
//---------------------------------------------------------------------------
//   iis4r       

double Spline::iis4r(std::vector<double> *x,//  X  
					 std::vector<double> *y,//   Y   x
					 std::vector<double> *c0,//    
					 std::vector<double> *c1,
					 std::vector<double> *c2,
					 double u)//   X,     
{
	//      u
	//   *x=NULL,        X   1.

	double d,dd,s;
	int ierr, jer, ker;
	long j,nx,nxm1;
	long i = 1;

	nx=y->size();

	ierr =0;
	jer = 0;
	ker = 0;
	nxm1=nx-1;

	if (nx<2) { utii10(65,4); return(0.); }

	if (x) for (j=1; j<=nxm1; j++) if ((*x)[j]-(*x)[j-1]<0.) { utii10(66,4); return(0.); }

	if (i>nxm1) i=1;

	if (x) d=u-(*x)[i-1];
	else   d=u-(i-1);

	if (d<0.)		goto L3;
	else if (d==0.) goto L7;
	else			goto L5;
L3:
	if (i==1) goto L8;

	i--;
	if (x) d=u-(*x)[i-1];
	else   d=u-(i-1);

	if (d<0.)		goto L3;
	else if (d==0.) goto L7;
	else			goto L6;
L4:
	i++;
	d=dd;
L5:
	if (i>=nx) goto L9;

	if (x) dd=u-(*x)[i];
	else   dd=u-i;

	if (dd>=0.) goto L4;
	if (d==0.)  goto L7;

L6:
	s=(((*c2)[i-1]*d+(*c1)[i-1])*d+(*c0)[i-1])*d+(*y)[i-1];
	goto L10;
L7:
	s=(*y)[i-1];
	goto L10;
L8:
	jer = 1;
	goto L6;
L9:
	if (dd>0.) ker = 2;

	if (x) d=u-(*x)[nxm1-1];
	else   d=u-(nxm1-1);

	i=nxm1;
	goto L6;
L10:
	ierr = __max(jer,ker);

	if (ierr) utii10(ierr, 4);

	return (s);
}
//---------------------------------------------------------------------------

void Spline::utii10(int ierr, int n)
{
	CString s;

	s="\n HB M\n OKA.  ";

	static char
	*Msg_302=" N  1 -      2.\n",
	*Msg_305=" N  2 -   X    .\n",
	*Msg_502=" N  1 -      X  2.\n",
	*Msg_504=" N  2 -      Y  2.\n",
	*Msg_506=" N  3 -   X    .\n",
	*Msg_508=" N  4 -   Y    .\n",
	*Msg_602=" N  5 -   LX ,  NX   1.\n",
	*Msg_604=" N  6 -   LY ,  NY   1.\n";

	switch (n)
	{
	case 1: s=s+"iis1r\nTOKA HTEPOPOBAH HE PHAET AAHHOM OHTEPBA.\n";
			break;
	case 2: s=s+"iis2r\nAAHHA TOKA HE ET BHTP HEPABHOMEPHO CETK.\n";
			break;
	case 3: s=s+"iis3r\n"; 
			switch (ierr)
			{
			case 65: s=s+Msg_302; break;
			case 66: s=s+Msg_305;
			}
			break;
	case 4: s=s+"iis4r\n"; 
			if (ierr>64)
			{
				switch (ierr)
				{
				case 65: s=s+Msg_302; break;
				case 66: s=s+Msg_305;
				}
			}
			else
			{
				switch (ierr)
				{
				case 1: s=s+"O      X      X.\n"; break;
				case 2: s=s+"O      X      X.\n";
				}
			}
			break;
	case 5: s=s+"iis5r";
			if (ierr>64)
			{
				
				switch (ierr)
				{
				case 65: s=s+Msg_502; break;
				case 66: s=s+Msg_504; break;
				case 67: s=s+Msg_506; break;
				case 68: s=s+Msg_508;
				}
			}
			else
			{
				switch (ierr)
				{
				case 1: s=s+" N  1 - OHA  HECKOKO AAHHX TOEK CETK XL MEHE X[0]\n"
				"  OE X(NX).\n"; break;
				case 2: s=s+" N  2 - OHA  HECKOKO AAHHX TOEK CETK YL MEHE Y[0]\n"
				"  OE Y(NY).\n";
				} 
			}
			break;
	case 6: s=s+"IIS6r\n";
			switch (ierr)
			{
			case 65: s=s+Msg_502; break;
			case 66: s=s+Msg_504; break;
			case 67: s=s+Msg_506; break;
			case 68: s=s+Msg_508; break;
			case 69: s=s+Msg_602; break;
			case 70: s=s+Msg_604;
			}
			break;
	case 7: s=s+"iis7r\n";
			if (ierr>64)
			{
				switch (ierr)
				{
				case 65: s=s+Msg_502; break;
				case 66: s=s+Msg_504; break;
				case 67: s=s+Msg_506; break;
				case 68: s=s+Msg_508; break;
				case 69: s=s+Msg_602; break;
				case 70: s=s+Msg_604;
				}
			}
			else
			{
				switch (ierr)
				{
				case 1: s=s+" N  1 - ACCCA XL AAHHO TOK (XL,YL) MEHE X(LX) \n"
				"OE X(LX+1).\n"; break;
				case 2: s=s+" N  2 - OPHATA YL AAHHO TOK (XL,YL) MEHE Y(LY) \n"
				"OE Y(LY+1).\n";
				}
			}
			break;
	case  8:s=s+"iis8r\nN  1 -       .\n";
			break;
	case  9: s=s+"iis9R\n";
			switch (ierr)
			{
			case 65: s=s+" N  1 - AAHHOE KOECTBO OB CETK MEHE ETPEX.\n"; break;
			case 66: s=s+" N  2 - ACCC TAHX HAEH HTEPOPEMO HK\n"
			"        HE BTC CTPOO MOHOTOHHO BOPACTAM.\n";
			}
			break;
	case 20: s=s+"ii20r\n"; 
			switch (ierr)
			{
			case 65: s=s+" N  1 - HAEHH HAMEHATE MEET KOPEH B AAHHOM HTEPBAE.\n"; break;
			case 66: s=s+" N  2 - MATPA  OPEEEH KOEHTOB APOKCMA BPOEHA.\n";
			}
			break;
	case 21: s=s+"ii21r\n"; 
			switch (ierr)
			{
			case 65: s=s+" N  1 -  HTEPO BXOT A HTEPBA OPEEEH B-CAHOB.\n"; break;
			case 66: s=s+" N  2 - MATPA  OPEEEH KOEHTOB BPOEHA.\n";
			}
			break;
	case 22: s=s+"ii22r\n"; 
			switch (ierr)
			{
			case 65: s=s+" N  1 -        X.\n"; break;
			case 66: s=s+" N  2 -     2*NN+1.\n";
			}
			break;
	default: ASSERT(0);
	}
	AfxMessageBox(s);
}
//---------------------------------------------------------------------------

void Spline::test()
{
    long i,j,nScale;
	double angle,dx,dy,sum;
    double bpar[4];
	std::vector<double> xiis, xiis0,uiis,uiis0;
	std::vector<double> cx0,cx1,cx2,	cy0,cy1,cy2;
	std::vector<double> cx0_,cx1_,cx2_, cy0_,cy1_,cy2_;

//--- 1D  0 ---
	int nx=5;
	int m=41;

	y.resize(nx);
	u.resize(m);

	for (i=0; i<m; i++)	 u[i]=i*(nx-1.)/(m-1.);
	for (i=0; i<nx; i++) y[i]=(i-3.)*i*(i+1.)+5.;


	bpar[0]=1.;
	bpar[1]=6.*((y[1]-y[0])+6.);
	bpar[2]=1.;
	bpar[3]=6.*(34.-(y[4]-y[3]));


	iis3r(NULL,&y, bpar, &c0,&c1,&c2);
	iis4r(NULL,&y, &c0,&c1,&c2, &u,&s);

//--- 2D  1 ---

	bpar[0]=1.;	bpar[1]=0.;
	bpar[2]=1.;	bpar[3]=0.;

	nScale=100;

	RX1.resize(18);	RY1.resize(RX1.size());

	RX1[0]=0.;		RY1[0]=0.;
	RX1[1]=1.;		RY1[1]=1.2;
	RX1[2]=2.2;		RY1[2]=2.6;
	RX1[3]=3.0;		RY1[3]=3.4;
	RX1[4]=3.7;		RY1[4]=4.2;
	RX1[5]=3.8;		RY1[5]=4.175;
	RX1[6]=6.4;		RY1[6]=3.9;
	RX1[7]=8.2;		RY1[7]=3.7;
	RX1[8]=9.5;		RY1[8]=3.;
	RX1[9]=8.6;		RY1[9]=2.4;
	RX1[10]=8.6;	RY1[10]=0.8;
	RX1[11]=7.;		RY1[11]=0.;
	RX1[12]=6.;		RY1[12]=0.;
	RX1[13]=6.5;	RY1[13]=-1.5;
	RX1[14]=12.65;	RY1[14]=2.4;
	RX1[15]=13;		RY1[15]=2.6;
	RX1[16]=13;		RY1[16]=1.;
	RX1[17]=14;		RY1[17]=1.;

	uiis0.clear();
	uiis0.push_back(0.);

	for (j=1; j<RX1.size(); j++)
	for (i=1; i<=nScale; i++)	uiis0.push_back(j-1+(double)i/nScale);

	xiis.resize(RX1.size());
	xiis[0]=0.;
	sum=0.;
	for (j=1; j<RX1.size(); j++)
	{
			dx=RX1[j]-RX1[j-1];
			dy=RY1[j]-RY1[j-1];
			sum+=sqrt(dx*dx+dy*dy);
		xiis[j]=sum;
	}

	uiis.clear();
	uiis.push_back(xiis[0]);
	for (j=1; j<xiis.size(); j++)
	for (i=1; i<=nScale; i++) uiis.push_back(xiis[j-1]+(xiis[j]-xiis[j-1])*i/nScale);

	iis3r(NULL,&RX1, bpar, &cx0,&cx1,&cx2);
	iis3r(NULL,&RY1, bpar, &cy0,&cy1,&cy2);
	iis4r(NULL,&RX1, &cx0,&cx1,&cx2, &uiis0,&splRX1);
	iis4r(NULL,&RY1, &cy0,&cy1,&cy2, &uiis0,&splRY1);

	iis3r(&xiis,&RX1, bpar, &cx0_,&cx1_,&cx2_);
	iis3r(&xiis,&RY1, bpar, &cy0_,&cy1_,&cy2_);
	iis4r(&xiis,&RX1, &cx0_,&cx1_,&cx2_, &uiis,&splRX1_);
	iis4r(&xiis,&RY1, &cy0_,&cy1_,&cy2_, &uiis,&splRY1_);

//--- 2D  2 ---

	bpar[0]=1.;	bpar[1]=0.;
	bpar[2]=1.;	bpar[3]=0.;

	long ns=10;
	for (j=0; j<ns; j++)
	{
		angle=Pi2*j/(ns-1);
		RX2.push_back(cos(angle));
		RY2.push_back(sin(angle));

		if (j==ns/3)
		{
			angle=angle+0.2*(Pi2/(ns-1));
			RX2.push_back(cos(angle));
			RY2.push_back(sin(angle));
		}
		if (j==2*(ns/3))
		{
			angle=angle+0.1*(Pi2/(ns-1));
			RX2.push_back(cos(angle));
			RY2.push_back(sin(angle));
		}
	}

	uiis0.clear();
	uiis0.push_back(0.);
	for (j=1; j<RX2.size(); j++)
	for (i=1; i<=nScale; i++)	uiis0.push_back(j-1+(double)i/nScale);

	xiis.resize(RX2.size());
	xiis[0]=0.;
	sum=0.;
	for (j=1; j<RX2.size(); j++)
	{
			dx=RX2[j]-RX2[j-1];
			dy=RY2[j]-RY2[j-1];
			sum+=sqrt(dx*dx+dy*dy);
		xiis[j]=sum;
	}

	uiis.clear();
	uiis.push_back(xiis[0]);
	for (j=1; j<xiis.size(); j++)
	for (i=1; i<=nScale; i++) uiis.push_back(xiis[j-1]+(xiis[j]-xiis[j-1])*i/nScale);

	iis3r(NULL,&RX2, bpar, &cx0,&cx1,&cx2);
	iis3r(NULL,&RY2, bpar, &cy0,&cy1,&cy2);
	iis4r(NULL,&RX2, &cx0,&cx1,&cx2, &uiis0,&splRX2);
	iis4r(NULL,&RY2, &cy0,&cy1,&cy2, &uiis0,&splRY2);

	iis3r(&xiis,&RX2, bpar, &cx0_,&cx1_,&cx2_);
	iis3r(&xiis,&RY2, bpar, &cy0_,&cy1_,&cy2_);
	iis4r(&xiis,&RX2, &cx0_,&cx1_,&cx2_, &uiis,&splRX2_);
	iis4r(&xiis,&RY2, &cy0_,&cy1_,&cy2_, &uiis,&splRY2_);

//--- 2D  3 ---

	for (j=0; j<ns; j++)
	{
		angle=Pi2*j/(ns-1);
		RX3.push_back(cos(angle));
		RY3.push_back(sin(angle));

		if (j==ns/3)
		{
			angle=angle+0.2*(Pi2/(ns-1));
			RX3.push_back(cos(angle));
			RY3.push_back(sin(angle));
		}
		if (j==2*(ns/3))
		{
			angle=angle+0.1*(Pi2/(ns-1));
			RX3.push_back(cos(angle));
			RY3.push_back(sin(angle));
		}

		if (j==ns/2) //      ,   
		{
			RX3.push_back(RX3[RX3.size()-1]);
			RY3.push_back(RY3[RY3.size()-1]);
		}
	}

	uiis0.clear();
	uiis0.push_back(0.);

	for (j=1; j<RX3.size(); j++)
	for (i=1; i<=nScale; i++)	uiis0.push_back(j-1+(double)i/nScale);

	xiis.resize(RX3.size());
	xiis[0]=0.;
	sum=0.;
	for (j=1; j<RX3.size(); j++)
	{
			dx=RX3[j]-RX3[j-1];
			dy=RY3[j]-RY3[j-1];
			sum+=sqrt(dx*dx+dy*dy);
		xiis[j]=sum;
	}

	uiis.clear();
	uiis.push_back(xiis[0]);
	for (j=1; j<xiis.size(); j++)
	for (i=1; i<=nScale; i++) uiis.push_back(xiis[j-1]+(xiis[j]-xiis[j-1])*i/nScale);

	iis3r(NULL,&RX3, bpar, &cx0,&cx1,&cx2);
	iis3r(NULL,&RY3, bpar, &cy0,&cy1,&cy2);
	iis4r(NULL,&RX3, &cx0,&cx1,&cx2, &uiis0,&splRX3);
	iis4r(NULL,&RY3, &cy0,&cy1,&cy2, &uiis0,&splRY3);

	iis3r(&xiis,&RX3, bpar, &cx0_,&cx1_,&cx2_);
	iis3r(&xiis,&RY3, bpar, &cy0_,&cy1_,&cy2_);
	iis4r(&xiis,&RX3, &cx0_,&cx1_,&cx2_, &uiis,&splRX3_);
	iis4r(&xiis,&RY3, &cy0_,&cy1_,&cy2_, &uiis,&splRY3_);

//--- 2D  4 ---

	for (j=0; j<ns; j++)
	{
		angle=Pi2*j/(ns-1);

		if (j==ns/3)
		{
			RX4.push_back(cos(angle));
			RY4.push_back(sin(angle));
			angle=angle+0.2*(Pi2/(ns-1));
			RX4.push_back(cos(angle));
			RY4.push_back(sin(angle));
			continue;
		}
		if (RX4.size()-1==5)
		{
//			angle=angle+0.1*(Pi2/(ns-1));
			RX4.push_back(cos(angle-0.01*(Pi2/(ns-1))));
			RY4.push_back(sin(angle-0.01*(Pi2/(ns-1))));

			RX4.push_back(cos(angle));
			RY4.push_back(sin(angle));

			RX4.push_back(RX4[RX4.size()-1]);
			RY4.push_back(RY4[RY4.size()-1]);
			RX4.push_back(cos(angle+0.01*(Pi2/(ns-1))));
			RY4.push_back(sin(angle+0.01*(Pi2/(ns-1))));
			continue;
		}
		RX4.push_back(cos(angle));
		RY4.push_back(sin(angle));
	}

	uiis0.clear();
	uiis0.push_back(0.);

	for (j=1; j<RX4.size(); j++)
	for (i=1; i<=nScale; i++)	uiis0.push_back(j-1+(double)i/nScale);

	xiis.resize(RX4.size());
	xiis[0]=0.;
	sum=0.;
	for (j=1; j<RX4.size(); j++)
	{
			dx=RX4[j]-RX4[j-1];
			dy=RY4[j]-RY4[j-1];
			sum+=sqrt(dx*dx+dy*dy);
		xiis[j]=sum;
	}

	uiis.clear();
	uiis.push_back(xiis[0]);
	for (j=1; j<xiis.size(); j++)
	for (i=1; i<=nScale; i++) uiis.push_back(xiis[j-1]+(xiis[j]-xiis[j-1])*i/nScale);

	iis3r(NULL,&RX4, bpar, &cx0,&cx1,&cx2);
	iis3r(NULL,&RY4, bpar, &cy0,&cy1,&cy2);
	iis4r(NULL,&RX4, &cx0,&cx1,&cx2, &uiis0,&splRX4);
	iis4r(NULL,&RY4, &cy0,&cy1,&cy2, &uiis0,&splRY4);

	iis3r(&xiis,&RX4, bpar, &cx0_,&cx1_,&cx2_);
	iis3r(&xiis,&RY4, bpar, &cy0_,&cy1_,&cy2_);
	iis4r(&xiis,&RX4, &cx0_,&cx1_,&cx2_, &uiis,&splRX4_);
	iis4r(&xiis,&RY4, &cy0_,&cy1_,&cy2_, &uiis,&splRY4_);
}
//---------------------------------------------------------------------------