// chart.cpp : implementation file
//

#include "stdafx.h"
#include "DebugCalculation.h"
#include "MainFrm.h"
#include "chart.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//---------------------------------------------------------------------------
extern double dScale;
//extern long nPos1,nPos2;
extern	double aX0,aY0, aX1,aY1;

//---------------------------------------------------------------------------
/////////////////////////////////////////////////////////////////////////////
//	Chart v 1.0
//
//	  
//
//	  	byvshikh@mail.ru
//

IMPLEMENT_DYNCREATE(Chart, CMDIChildWnd)

Chart::Chart(CHARTS n, Data* dd)
{
	eChart=n;//       MainFrm
	d=dd;	 //   Data

	nBorder=10;

	xScale=1.;
	yScale=1.;
	yScale0=1.;

	Scale=1.;

	disp.x=0.;
	disp.y=0.;
	dispBMP.x=0;
	dispBMP.y=0;

	sizeDragRect.cx=1;
	sizeDragRect.cy=1;

//	bSynArraysSizes=FALSE;
	bIsProportional=TRUE;
	bPaintFromZero=FALSE;
	bPaintCircles=FALSE;
	bIsRangeDefined=FALSE;
	bDontPaintNegatives=FALSE;
	bAreDifferentXYScales=FALSE;

	nArrays=0;

	penBLACK.CreatePen(PS_SOLID,1,RGB(0,0,0));
	penGRAY.CreatePen(PS_SOLID,1,RGB(128,128,128));
	penGRAY_LIGHT.CreatePen(PS_SOLID,1,RGB(220,220,220));

	brushWHITE.CreateSolidBrush(RGB(255,255,255));
	brushYELLOW.CreateSolidBrush(RGB(255,255,217));
}
//---------------------------------------------------------------------------

Chart::~Chart()
{
	((CMainFrame*)m_pParent)->pChart[eChart]=NULL;
}


BEGIN_MESSAGE_MAP(Chart, CMDIChildWnd)
	//{{AFX_MSG_MAP(Chart)
	ON_WM_PAINT()
	ON_WM_SIZE()
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONUP()
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	ON_COMMAND(ID_BUTTON_ZERO_POS, OnButtonZeroPos)
	ON_COMMAND(ID_BUTTON_PLUS, OnButtonPlus)
	ON_COMMAND(ID_BUTTON_MINUS, OnButtonMinus)
	ON_COMMAND(ID_BUTTON_PLUS_X, OnButtonPlusX)
	ON_COMMAND(ID_BUTTON_MINUS_X, OnButtonMinusX)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Chart message handlers
//---------------------------------------------------------------------------

void Chart::SetInitial()
{//       

	xScale=1.;
	Scale=yScale0;

	dispBMP.x=0;
	dispBMP.y=0;

	sizeDragRect.cx=1;
	sizeDragRect.cy=1;

	SetArraysSizes();

	bIsRangeDefined=FALSE;
	DefineMinMax();
}
//---------------------------------------------------------------------------

void Chart::OnButton() 
{
//AfxMessageBox("Chart::OnButton()");
	if (m_dc)
	{
		PaintChart(&m_dc); //    bitmap

		dispBMP.x=0; //   bitmap    
		dispBMP.y=0; // (      bitmap)

		CClientDC dc(this); //  bitmap   
		dc.BitBlt(dispBMP.x,dispBMP.y, sizeClient.cx,sizeClient.cy, &m_dc, 0,0, SRCCOPY);
	}
}
//---------------------------------------------------------------------------

BOOL Chart::Create(LPCTSTR szTitle, LONG style /* = 0 */,
	const RECT& rect /* = rectDefault */,
	CMDIFrameWnd* parent /* = NULL */)
{
	m_pParent = parent;

	// Register a custom WndClass and create a window.
	// This must be done because CBounceWnd has a custom cursor, and
	//  no icon.
	LPCTSTR lpszBounceClass =
		AfxRegisterWndClass(CS_HREDRAW | CS_VREDRAW,
			LoadCursor(NULL, IDC_ARROW),
			(HBRUSH)(COLOR_WINDOW+1),
			NULL);
	return CMDIChildWnd::Create(lpszBounceClass, szTitle, style, rect, parent);
}
//---------------------------------------------------------------------------

void Chart::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	dc.BitBlt(dispBMP.x, dispBMP.y, sizeClient.cx, sizeClient.cy, &m_dc, 0, 0, SRCCOPY);
}

//---------------------------------------------------------------------------

BOOL Chart::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext) 
{
//AfxMessageBox("Chart::OnCreateClient()");

	CClientDC dc(this);
	//   ,    
	if(!m_dc.CreateCompatibleDC(NULL)) 
		AfxMessageBox("Chart: !m_dc.CreateCompatibleDC(NULL)");

	BITMAP bm;//  BITMAP 
	bm.bmType      = 0;
	bm.bmWidth     = dc.GetDeviceCaps(HORZRES);
	bm.bmHeight    = dc.GetDeviceCaps(VERTRES);
	bm.bmPlanes    = dc.GetDeviceCaps(PLANES);
	bm.bmBitsPixel = dc.GetDeviceCaps(BITSPIXEL);
	bm.bmBits      = NULL;
	bm.bmWidthBytes  = (int)bm.bmBitsPixel*bm.bmWidth/8+2;

	//  BITMAP
	if(!bitmap.CreateBitmapIndirect(&bm))
		AfxMessageBox("Chart: !bitmap.CreateBitmapIndirect(&bm)");

	pOldBitmap = m_dc.SelectObject(&bitmap); //  BITMAP   

	CRect rect;
	GetClientRect(&rect);
	sizeClient=rect.Size(); //     

	OnButtonZeroPos();

	return CMDIChildWnd::OnCreateClient(lpcs, pContext);
}
//---------------------------------------------------------------------------

void Chart::OnButtonZeroPos() 
{//       
//AfxMessageBox("Chart::OnButtonZeroPos()");

	Scale=1.;
	xScale=1.;

	yScale=yScale0;

	GetClientRect(r);
	sizeClient=r.Size();

	r.top+=nBorder;
	r.bottom-=nBorder;
	r.left+=nBorder;
	r.right-=nBorder; // rect    

	if ((bIsProportional)&&(!bAreDifferentXYScales))
	{
		if ( ((yMax-yMin)/(xMax-xMin)) >
					((double)(r.bottom-r.top)/(r.right-r.left)))
		{//    ,      
			yCoeff=(r.bottom-r.top)/(yMax-yMin);
			xCoeff=yCoeff;
			disp.y=(r.bottom-r.top-(yMax-yMin)*yCoeff*yScale)/2;
		}
		else
		{
			xCoeff=(r.right-r.left)/(xMax-xMin);
			yCoeff=xCoeff;
			disp.y=-(r.bottom-r.top-(yMax-yMin)*yCoeff*yScale)/2;
		}
	}
	else
	{
		yCoeff=(r.bottom-r.top)/(yMax-yMin);
		xCoeff=(r.right-r.left)/(xMax-xMin);

		disp.y=(r.bottom-r.top-(yMax-yMin)*yCoeff)/2;
	}
	disp.x=(r.right-r.left-(xMax-xMin)*xCoeff)/2;

	OnButton();
}
//---------------------------------------------------------------------------

void Chart::OnRButtonDown(UINT nFlags, CPoint point) 
{
	SetCursor(AfxGetApp()->LoadStandardCursor(IDC_SIZEALL));
	oldPoint=point; //  ,     

	//  -  
	CClientDC dc(this);
	oldpen=dc.SelectObject(&penBLACK);

	dc.MoveTo((int)(sizeClient.cx/2)-10,(int)(sizeClient.cy/2));
	dc.LineTo((int)(sizeClient.cx/2)+10,(int)(sizeClient.cy/2));

	dc.MoveTo((int)(sizeClient.cx/2),(int)(sizeClient.cy/2)-10);
	dc.LineTo((int)(sizeClient.cx/2),(int)(sizeClient.cy/2)+10);

	dc.SelectObject(oldpen);

	CMDIChildWnd::OnRButtonDown(nFlags, point);
}
//---------------------------------------------------------------------------

void Chart::OnRButtonUp(UINT nFlags, CPoint point) 
{
	OnButton(); //  ,   
	
	CMDIChildWnd::OnRButtonUp(nFlags, point);
}
//---------------------------------------------------------------------------

void Chart::OnLButtonDown(UINT nFlags, CPoint point) 
{
	bNoScale=FALSE;

	pointLButtonDown=point;
	rNew.left=point.x;
	rNew.right=point.x;
	rNew.top=point.y;
	rNew.bottom=point.y;

	CClientDC dc(this);
	dc.DrawDragRect(rNew,sizeDragRect,NULL,sizeDragRect,&brushWHITE);
	rOld=rNew;

	if (!bIsProportional)
	{
		if (nFlags!=(MK_LBUTTON|MK_CONTROL)) OnButtonPlusX(); // (+)    X
		else								 OnButtonMinusX();// (-) 	 X
	}
	else
	{
		if (nFlags!=(MK_LBUTTON|MK_CONTROL)) OnButtonPlus(); // (+)   
		else								 OnButtonMinus();// (-) 	
	}

	CMDIChildWnd::OnLButtonDown(nFlags, point);
}
//---------------------------------------------------------------------------

void Chart::OnLButtonUp(UINT nFlags, CPoint point) 
{
	CClientDC dc(this);//   DragRect
	dc.DrawDragRect(CRect(0,0,0,0),sizeDragRect,rOld,sizeDragRect,&brushWHITE);

	if ((!bIsProportional)&&(bNoScale)) OnButtonZeroPos();
	
	CMDIChildWnd::OnLButtonUp(nFlags, point);
}
//---------------------------------------------------------------------------

void Chart::OnMouseMove(UINT nFlags, CPoint point) 
{
	CClientDC dc(this);

	switch(nFlags)
	{
		case MK_LBUTTON: //      DragRect
		{
		if ((bIsProportional)&&(!bAreDifferentXYScales))
			{//  DragRect    
				if ((point.x>rNew.left)&&(point.y>rNew.top))
				{
					double Mc=(double)sizeClient.cx/sizeClient.cy;
					double M;

	//				if ((point.y-rNew.bottom)!=0)
						M=(double)(point.x-rNew.left)/(point.y-rNew.bottom);
	//				else
	//					M=(double)(point.y-rNew.bottom)/(point.x-rNew.left);

					if (M>Mc)
					{
						rNew.right=point.x;
						rNew.bottom=(int)((double)(rNew.right-rNew.left)/M)+rNew.bottom;
					}
					else
					{
						rNew.bottom=point.y;
						rNew.right=(int)((double)(rNew.bottom-rNew.top)*M)+rNew.left;
					}
				}
			}
			else
			{
				rNew.left=pointLButtonDown.x;
				rNew.top=pointLButtonDown.y;
				rNew.right=point.x;
				rNew.bottom=point.y;

				bNoScale=FALSE;
				if((rNew.left>rNew.right)||(rNew.top>rNew.bottom)) 
				{
					rNew.NormalizeRect();
					if (((rNew.right-rNew.left)>2)&&((rNew.bottom-rNew.top)>2))
					bNoScale=TRUE; //   
				}
			}
			dc.DrawDragRect(rNew,sizeDragRect,rOld,sizeDragRect,&brushWHITE);
			rOld=rNew;
			break;
		}//- - - - - - - - - - - - - - - - - - - - - - - - -
		case MK_RBUTTON: //  bitmap  
		{	
			SetCursor(AfxGetApp()->LoadStandardCursor(IDC_SIZEALL));

			disp.x += point.x-oldPoint.x;
			disp.y += point.y-oldPoint.y;

			dispBMP.x += point.x-oldPoint.x;
			dispBMP.y += point.y-oldPoint.y;

			oldPoint=point;

			//          
			CRect rcClient;
			GetClientRect(rcClient);
			dc.FillRect(rcClient,&brushYELLOW);

			//  bitmap     
			dc.BitBlt(dispBMP.x, dispBMP.y, sizeClient.cx, sizeClient.cy, &m_dc, 0, 0, SRCCOPY);

			//  -  
			oldpen=dc.SelectObject(&penBLACK);

			dc.MoveTo((int)(sizeClient.cx/2)-10,(int)(sizeClient.cy/2));
			dc.LineTo((int)(sizeClient.cx/2)+10,(int)(sizeClient.cy/2));

			dc.MoveTo((int)(sizeClient.cx/2),(int)(sizeClient.cy/2)-10);
			dc.LineTo((int)(sizeClient.cx/2),(int)(sizeClient.cy/2)+10);

			dc.SelectObject(oldpen);
			break;
		}
	}

	CMDIChildWnd::OnMouseMove(nFlags, point);
}
//---------------------------------------------------------------------------

void Chart::OnButtonPlus() 
{ // (+)  
	Scale=dScale;

	xScale=xScale*Scale;
	disp.x=disp.x*Scale+(sizeClient.cx-2*nBorder)*(1.0-Scale)*0.5;

	if (bIsProportional)
	{
		yScale=yScale*Scale;
		disp.y=disp.y*Scale+(sizeClient.cy-2*nBorder)*(Scale-1.0)*0.5;
	}
	OnButton();
}
//---------------------------------------------------------------------------

void Chart::OnButtonMinus() 
{// (-) 
	Scale=1./dScale;

	xScale=xScale*Scale;
	disp.x=disp.x*Scale+(sizeClient.cx-2*nBorder)*(1.0-Scale)*0.5;

	if (bIsProportional)
	{
		yScale=yScale*Scale;
		disp.y=disp.y*Scale+(sizeClient.cy-2*nBorder)*(Scale-1.0)*0.5;
	}
	OnButton();
}
//---------------------------------------------------------------------------

void Chart::OnButtonPlusX() 
{ // (+)    X
	Scale=dScale;

	xScale=xScale*Scale;
	disp.x=disp.x*Scale+(sizeClient.cx-2*nBorder)*(1.0-Scale)*0.5;

	OnButton();
}
//---------------------------------------------------------------------------

void Chart::OnButtonMinusX() 
{// (-)   X
	Scale=1./dScale;

	xScale=xScale*Scale;
	disp.x=disp.x*Scale+(sizeClient.cx-2*nBorder)*(1.0-Scale)*0.5;

	OnButton();
}
//---------------------------------------------------------------------------

void Chart::OnSize(UINT nType, int cx, int cy) 
{
	CMDIChildWnd::OnSize(nType, cx, cy);

	if (nType==SIZE_MINIMIZED) return;

	GetClientRect(r);

	r.top+=nBorder;
	r.bottom-=nBorder;
	r.left+=nBorder;
	r.right-=nBorder; // rect    

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
/*
	if (!bIsRangeDefined)
	{
		DefineMinMax();

		yCoeff=(r.bottom-r.top)/(yMax-yMin);
		xCoeff=(r.right-r.left)/(xMax-xMin);

		disp.y=(r.bottom-r.top-(yMax-yMin)*yCoeff)/2;
		disp.x=(r.right-r.left-(xMax-xMin)*xCoeff)/2;

//		bIsRangeDefined=FALSE;
	}
*/
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	if ((bIsProportional)&&(!bAreDifferentXYScales))
	{
		if ( ((yMax-yMin)/(xMax-xMin)) >
					((double)(r.bottom-r.top)/(r.right-r.left)))
		{//    ,      
			yCoeff=(r.bottom-r.top)/(yMax-yMin);
			xCoeff=yCoeff;
		}
		else
		{
			xCoeff=(r.right-r.left)/(xMax-xMin);
			yCoeff=xCoeff;
		}
	}
	else
	{
		yCoeff=(r.bottom-r.top)/(yMax-yMin);
		xCoeff=(r.right-r.left)/(xMax-xMin);
	}

//    
	disp.x=disp.x*cx/sizeClient.cx;
	disp.y=disp.y*cy/sizeClient.cy;

	sizeClient.cx=cx;
	sizeClient.cy=cy;

	OnButton();
}
//---------------------------------------------------------------------------

void Chart::PaintChart(CDC* m_dc)
{//  

	long k,kx0,kx1,ky0,ky1;
	int ix0,iy0,ix1,iy1, istep,j, n=0, len;
	double cfx,cfy;
	CString s;

	if (nArrays<=0) 
	{
		#ifdef _DEBUG
			s.Format("Chart::PaintChart():    (nArrays=%i)",nArrays);
			AfxMessageBox(s);
		#endif
		return;
	} else if (nArrays>N_ARRAYS_MAX)
	{
		#ifdef _DEBUG
			s.Format("Chart::PaintChart():     (nArrays=%i)",nArrays);
			AfxMessageBox(s);
		#endif
		return;
	}

	SetCursor(AfxGetApp()->LoadStandardCursor(IDC_WAIT));

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
	if (!bIsRangeDefined)
	{
		DefineMinMax();

		GetClientRect(r);
		sizeClient=r.Size();

		r.top+=nBorder;
		r.bottom-=nBorder;
		r.left+=nBorder;
		r.right-=nBorder; // rect    

	if ((bIsProportional)&&(!bAreDifferentXYScales))
		{
			if ( ((yMax-yMin)/(xMax-xMin)) >
						((double)(r.bottom-r.top)/(r.right-r.left)))
			{//    ,      
				yCoeff=(r.bottom-r.top)/(yMax-yMin);
				xCoeff=yCoeff;
				disp.y=(r.bottom-r.top-(yMax-yMin)*yCoeff)/2;
			}
			else
			{
				xCoeff=(r.right-r.left)/(xMax-xMin);
				yCoeff=xCoeff;
				disp.y=-(r.bottom-r.top-(yMax-yMin)*yCoeff)/2;
			}
		}
		else
		{
			yCoeff=(r.bottom-r.top)/(yMax-yMin);
			xCoeff=(r.right-r.left)/(xMax-xMin);

			disp.y=(r.bottom-r.top-(yMax-yMin)*yCoeff)/2;
		}
		disp.x=(r.right-r.left-(xMax-xMin)*xCoeff)/2;
	}
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
	cfx=xCoeff*xScale;
	cfy=yCoeff*yScale;

	CRect rcClient;
	GetClientRect(rcClient);
	m_dc->FillRect(rcClient,&brushYELLOW); //    
/*

	str.Format(" =%d, =%d .",
		d->GPSz.size(),(int)(((double)d->GPSz.size())/60.0));

	m_dc->TextOut(50,r.bottom-40,str,str.GetLength());

//    
//	oldpen=m_dc->SelectObject(&penBLACK);
//	m_dc->Rectangle(r);
	m_dc->MoveTo(0,0);
	m_dc->LineTo(sizeClient.cx-1,0);
	m_dc->LineTo(sizeClient.cx-1,sizeClient.cy-1);
	m_dc->LineTo(0,sizeClient.cy-1);
	m_dc->LineTo(0,0);
*/
	CRect rDraw;

	rDraw.left=r.left+(int)(disp.x);
	rDraw.right=r.left+(int)((xMax-xMin)*cfx+disp.x);
	rDraw.bottom=r.bottom+(int)(disp.y);
	rDraw.top=r.bottom-(int)((yMax-yMin)*cfy-disp.y);

//   
	oldpen=m_dc->SelectObject(&penGRAY);
	m_dc->Rectangle(rDraw);
	sizeDraw=rDraw.Size();

// ---- (   X) -------------------------------------- 

	double Xmax,Xmin, mXmax,mXmin, eXmax,eXmin;
	double dX,mdX,edX,eX,eY;
	double DiffMeaningNumber;

	//    Xmax, Xmin
	double MaxMeaningNumber,mMaxMeaningNumber,eMaxMeaningNumber; 
	double MinMeaningNumber,mMinMeaningNumber,eMinMeaningNumber;
	double ConstantX,ConstantY,eConstant;	//     Xmax, Xmin

	double nMaxMeaningDigit;//     Xmax  Xmin 
	double nMinMeaningDigitX,nMinMeaningDigitY;

	int nLinesX,nLinesY;			 //   
	double mLines,eLinesX,eLinesY;//    
	int precisionX,precisionY;	 //   -1

	double StepX,StepY; //     ( )
	char chX,chY;


//  .  .    X (Xmax, Xmin)  dX
	Xmax=xMin+(r.right-r.left-disp.x)/(scaleLabelX*cfx);
	Xmin=xMin-disp.x/(scaleLabelX*cfx);

	dX=fabs(Xmax-Xmin);

//     dX
	me(dX, &mdX, &edX);

	me(Xmax, &mXmax, &eXmax);
	me(Xmin, &mXmin, &eXmin);

	double n1,n2;
	modf(mXmax, &n1);
	modf(mXmin, &n2);

//      Xmax, Xmin
	if ((Xmin*Xmax<=0.0)||(eXmax!=eXmin)) ConstantX=0.;
	else if (n1!=n2) ConstantX=0.0;
	else ConstantX=(double)((int)(Xmin*pow((double)10., -edX-1)))*pow((double)10., edX+1);

	me(ConstantX ,&mLines, &eConstant);

//     Xmax, Xmin
	MaxMeaningNumber=Xmax-ConstantX;
	MinMeaningNumber=Xmin-ConstantX;

//      Xmax, Xmin
	modf(mdX, &DiffMeaningNumber);
	DiffMeaningNumber *= pow((double)10.0, edX);

//  max  min  
	me(MaxMeaningNumber, &mMaxMeaningNumber, &eMaxMeaningNumber);
	me(MinMeaningNumber, &mMinMeaningNumber, &eMinMeaningNumber);

	modf(mMaxMeaningNumber, &nMaxMeaningDigit);
	modf(mMinMeaningNumber, &nMinMeaningDigitX);

	eX=__max(eMaxMeaningNumber,eMinMeaningNumber);

//  eMaxMeaningNumber  eMinMeaningNumber   ,
//  nMinMeaningDigitX  nMaxMeaningDigit    :

	if (eMaxMeaningNumber!=eMinMeaningNumber)
	{
		if (eMinMeaningNumber<eX)
		{
			eMinMeaningNumber=eX;
			nMinMeaningDigitX=0;
		}

		if (eMaxMeaningNumber<eX)
		{
			eMaxMeaningNumber=eX;
			nMaxMeaningDigit=0;
		}
	}

//    (nLines)
	me(DiffMeaningNumber, &mLines, &eLinesX);

// nLines =    DiffMeaningNumber
	nLinesX=(int)mLines;
if (nLinesX>10) nLinesX=nLinesX/2;

	double stp[]={ 1.0, 0.5, 0.2, 0.1 };

	istep=0;
	if (nLinesX==1) { istep++; nLinesX++; }
	StepX=stp[istep];


//      Step,      
	CString str1;
double	eMax=__max(eX,eConstant);
		eMax=__max(eLinesX,eMax);

	for (j=istep; j<4; j++)
	{
		precisionX=-eLinesX; //    
		if (StepX<1.0) precisionX++;

		if ((eMax<-5)||(eMax>5))
		{
			precisionX=eMax+precisionX;
			chX='e';
		}
		else chX='f';

		if ((eLinesX>=1.0)||((StepX==1.0)&&(eLinesX==0.0))) precisionX=0;

		//   
		format(&str1,ConstantX+nMinMeaningDigitX*pow((double)10.0, eX)+stp[j]*pow((double)10.0, eLinesX),chX,precisionX);

		len=str1.GetLength()*8+20; //  
		if (len<50) len=50;

		if ((int)(stp[j]*pow((double)10.0, eLinesX)*(scaleLabelX*cfx))<len) break;

		StepX=stp[j];
		nLinesX=(int)(dX/(StepX*pow((double)10.0, eLinesX)));
	}

//  

	m_dc->SelectObject(penGRAY_LIGHT);
	m_dc->SetTextAlign(TA_CENTER);

kx0=(long)(((-disp.x)/cfx+xMin)/scaleLabelX-ConstantX-nMinMeaningDigitX*pow((double)10.0, eX))/(StepX*pow((double)10.0, eLinesX) );
kx1=(long)(((r.right-r.left-disp.x)/cfx+xMin)/scaleLabelX-ConstantX-nMinMeaningDigitX*pow((double)10.0, eX))/(StepX*pow((double)10.0, eLinesX) );
k=__min(kx0,kx1);
kx1=__max(kx0,kx1)+102;
kx0=k-102;
	for (k=kx0; k<=kx1; k++)
	{
		ix0=r.left+(int)(( (ConstantX+nMinMeaningDigitX*pow((double)10.0, eX)+StepX*k*pow((double)10.0, eLinesX))*scaleLabelX-xMin)*cfx+disp.x);

		if (ix0>r.right) break;
		if (ix0>=r.left)
		{
			m_dc->MoveTo(ix0,r.bottom);
			m_dc->LineTo(ix0,r.top);
		}
	}

// ---- (   Y) -------------------------------------- 

//  .  .    Y (Xmax, Xmin)  dX

	Xmax=yMin+(r.bottom-r.top+disp.y)/(scaleLabelY*cfy);
	Xmin=yMin+disp.y/(scaleLabelY*cfy);

	dX=fabs(Xmax-Xmin);

//     dX
	me(dX, &mdX, &edX);

	me(Xmax, &mXmax, &eXmax);
	me(Xmin, &mXmin, &eXmin);

	modf(mXmax, &n1);
	modf(mXmin, &n2);

//      Xmax, Xmin
	if ((Xmin*Xmax<=0.)||(eXmax!=eXmin)) ConstantY=0.;
	else if (n1!=n2) ConstantY=0.;
	else ConstantY=(double)((int)(Xmin*pow((double)10., -edX-1)))*pow((double)10., edX+1);

	me(ConstantY ,&mLines, &eConstant);

//     Xmax, Xmin
	MaxMeaningNumber=Xmax-ConstantY;
	MinMeaningNumber=Xmin-ConstantY;

//      Xmax, Xmin
	modf(mdX, &DiffMeaningNumber);
	DiffMeaningNumber *= pow((double)10., edX);

//  max  min  
	me(MaxMeaningNumber, &mMaxMeaningNumber, &eMaxMeaningNumber);
	me(MinMeaningNumber, &mMinMeaningNumber, &eMinMeaningNumber);

	modf(mMaxMeaningNumber, &nMaxMeaningDigit);
	modf(mMinMeaningNumber, &nMinMeaningDigitY);

	eY=__max(eMaxMeaningNumber,eMinMeaningNumber);

//  eMaxMeaningNumber  eMinMeaningNumber   ,
//  nMinMeaningDigitY  nMaxMeaningDigit    :

	if (eMaxMeaningNumber!=eMinMeaningNumber)
	{
		if (eMinMeaningNumber<eY)
		{
			eMinMeaningNumber=eY;
			nMinMeaningDigitY=0;
		}

		if (eMaxMeaningNumber<eY)
		{
			eMaxMeaningNumber=eY;
			nMaxMeaningDigit=0;
		}
	}

//    (nLines)
	me(DiffMeaningNumber, &mLines, &eLinesY);

// nLines =    DiffMeaningNumber
	nLinesY=(int)mLines;
if (nLinesY>10) nLinesY=nLinesY/2;

	istep=0;
	if (nLinesY==1) { istep++; nLinesY++; }
	StepY=stp[istep];


//      Step,      
		eMax=__max(eY,eConstant);
		eMax=__max(eLinesY,eMax);

	for (j=istep; j<4; j++)
	{
		precisionY=-eLinesY; //    
		if (StepY<1.) precisionY++;

		if ((eMax<-5)||(eMax>5))
		{
			precisionY=eMax+precisionY;
			chY='e';
		}
		else
		{
			chY='f';
//			if (precisionY>10)	chY='e';
		}

		if ((eLinesY>=1.0)||((StepY==1.0)&&(eLinesY==0.0))) precisionY=0;


		len=50; // c    

		if ((int)(stp[j]*pow((double)10.0, eLinesY)*(scaleLabelY*cfy))<len) break;

		StepY=stp[j];
		nLinesY=(int)(dX/(StepY*pow((double)10.0, eLinesY)));
	}

//  

	m_dc->SelectObject(penGRAY_LIGHT);
	m_dc->SetTextAlign(TA_LEFT);

ky0=(long)((((r.bottom-r.top+disp.y)/cfy+yMin)/scaleLabelY-ConstantY-nMinMeaningDigitY*pow((double)10.0, eY))/(StepY*pow((double)10.0, eLinesY)));
ky1=(long)(((disp.y/cfy+yMin)/scaleLabelY-ConstantY-nMinMeaningDigitY*pow((double)10.0, eY))/(StepY*pow((double)10.0, eLinesY)));
k=__min(ky0,ky1);
ky1=__max(ky0,ky1)+102;
ky0=k-102;

	for (k=ky0; k<=ky1; k++)
	{
		iy0=r.bottom-(int)(( (ConstantY+nMinMeaningDigitY*pow((double)10.0, eY)+StepY*k*pow((double)10.0, eLinesY))*scaleLabelY-yMin)*cfy-disp.y);

		if (iy0<r.top) break;
		if (iy0<=r.bottom)
		{
			m_dc->MoveTo(r.left,iy0);
			m_dc->LineTo(r.right,iy0);
		}
	}
//    
	oldpen=m_dc->SelectObject(&penGRAY);
	m_dc->MoveTo(rDraw.left,rDraw.bottom);
	m_dc->LineTo(rDraw.left,rDraw.top);
	m_dc->LineTo(rDraw.right,rDraw.top);
	m_dc->LineTo(rDraw.right,rDraw.bottom);
	m_dc->LineTo(rDraw.left,rDraw.bottom);

//========   (nArrays ) =========

for (n=0; n<nArrays; n++)
{
	m_dc->SelectObject(pen[n]);


	if (bDrawPointsOnly[n])//   
	{
		if (pX[n]==NULL) ix0=r.left+(int)((nMin[n]-xMin)*cfx+disp.x);
		else			 ix0=r.left+(int)(((*pX[n])[nMin[n]]-xMin)*cfx+disp.x);

		iy0=r.bottom-(int)(((*pY[n])[nMin[n]]-yMin)*cfy-disp.y);

		m_dc->Ellipse(ix0-5,iy0-5,ix0+5,iy0+5);
		str.Format("%i",nMin[n]);
		m_dc->TextOut(ix0+7,iy0-8,str);
	}

	if (pX[n]==NULL)
	for (k=nMin[n]+1; k<=nMax[n]; k++)
	{
		if (pBool[n])// , /   
		{
			if ( (((std::vector<BOOL>*) pBool[n])->at(k))&&
				 (((std::vector<BOOL>*) pBool[n])->at(k-1)) )
			{
				ix0=r.left+(int)((k-1-xMin)*cfx+disp.x);
				ix1=r.left+(int)((k-xMin)*cfx+disp.x);

//				iy0=r.bottom-(int)(( ((std::vector<double>*) pY[n])->at(k-1)-yMin)*cfy-disp.y);
				iy0=r.bottom-(int)(((*pY[n])[k-1]-yMin)*cfy-disp.y);
				iy1=r.bottom-(int)(((*pY[n])[k]-yMin)*cfy-disp.y);
			}

			if (!bDrawPointsOnly[n])//  
			{
				m_dc->MoveTo(ix0,iy0);
				m_dc->LineTo(ix1,iy1);
			}
			else//  
			{
				m_dc->Ellipse(ix1-5,iy1-5,ix1+5,iy1+5);
				str.Format("%i",k);
				m_dc->TextOut(ix1+7,iy1-8,str);
			}

		}
		else//---------------
		{
			ix0=r.left+(int)((k-1-xMin)*cfx+disp.x);
			ix1=r.left+(int)((k-xMin)*cfx+disp.x);

			iy0=r.bottom-(int)(((*pY[n])[k-1]-yMin)*cfy-disp.y);
			iy1=r.bottom-(int)(((*pY[n])[k]-yMin)*cfy-disp.y);

			if (!bDrawPointsOnly[n])
			{
				m_dc->MoveTo(ix0,iy0);
				m_dc->LineTo(ix1,iy1);
			}
			else
			{
				m_dc->Ellipse(ix1-5,iy1-5,ix1+5,iy1+5);
				str.Format("%i",k);
				m_dc->TextOut(ix1+7,iy1-8,str);
			}
		}//-----------------
	}
	else
	for (k=nMin[n]+1; k<=nMax[n]; k++)
	{
		if (pBool[n])// , /   
		{
			if ( ((*pBool[n])[k])&&
				 ((*pBool[n])[k-1]) )
			{
				ix0=r.left+(int)(((*pX[n])[k-1]-xMin)*cfx+disp.x);
				ix1=r.left+(int)(((*pX[n])[k]-xMin)*cfx+disp.x);

				iy0=r.bottom-(int)(((*pY[n])[k-1]-yMin)*cfy-disp.y);
				iy1=r.bottom-(int)(((*pY[n])[k]-yMin)*cfy-disp.y);
			}
			if (!bDrawPointsOnly[n])
			{
				m_dc->MoveTo(ix0,iy0);
				m_dc->LineTo(ix1,iy1);
			}
			else
			{
				m_dc->Ellipse(ix1-5,iy1-5,ix1+5,iy1+5);
				str.Format("%i",k);
				m_dc->TextOut(ix1+7,iy1-8,str);
			}
		}
		else//---------------
		{
			ix0=r.left+(int)(((*pX[n])[k-1]-xMin)*cfx+disp.x);
			ix1=r.left+(int)(((*pX[n])[k]-xMin)*cfx+disp.x);

			iy0=r.bottom-(int)(((*pY[n])[k-1]-yMin)*cfy-disp.y);
			iy1=r.bottom-(int)(((*pY[n])[k]-yMin)*cfy-disp.y);

			if (!bDrawPointsOnly[n])
			{
				m_dc->MoveTo(ix0,iy0);
				m_dc->LineTo(ix1,iy1);
			}
			else
			{
				m_dc->Ellipse(ix1-5,iy1-5,ix1+5,iy1+5);
				str.Format("%i",k);
				m_dc->TextOut(ix1+7,iy1-8,str);
			}
		}//-----------------

		//     
		if (k==nMin[n]+1) m_dc->Ellipse(ix0-5,iy0-5,ix0+5,iy0+5);
	}
}

//////////////////////////////
/*
if (bPaintCircles)
{
	CPen pn;
	COLORREF clr;
	clr=RGB(0,0,0);
	pn.CreatePen(PS_SOLID,2,clr);
	m_dc->SelectObject(pn);
	int iRad=3;

	for (n=0; n<nArrays; n++)
	{
		if (pX[n]==NULL)
		for (k=nMin[n]; k<=nMax[n]; k++)
		{
			ix0=r.left+(int)((k-xMin)*cfx+disp.x);
			iy0=r.bottom-(int)(( ((std::vector<double>*) pY[n])->at(k)-yMin)*cfy-disp.y);

			if (k==nPos1)	iRad=6;
			else if (k==nPos2)	iRad=9;
			else			iRad=3;

//			m_dc->Ellipse(ix0-iRad,iy0-iRad,ix0+iRad,iy0+iRad);
			if ((k==nPos1)||(k==nPos2)) m_dc->Ellipse(ix0-iRad,iy0-iRad,ix0+iRad,iy0+iRad);
		}
		else//---------------
		for (k=nMin[n]; k<=nMax[n]; k++)
		{
			ix0=r.left+(int)(( ((std::vector<double>*) pX[n])->at(k)-xMin)*cfx+disp.x);
			iy0=r.bottom-(int)(( ((std::vector<double>*) pY[n])->at(k)-yMin)*cfy-disp.y);

			if (k==nPos1)		iRad=6;
			else if (k==nPos2)	iRad=9;
			else				iRad=3;

//			m_dc->Ellipse(ix0-iRad,iy0-iRad,ix0+iRad,iy0+iRad);
			if ((k==nPos1)||(k==nPos2)) m_dc->Ellipse(ix0-iRad,iy0-iRad,ix0+iRad,iy0+iRad);
		}
	}
	m_dc->SelectObject(pen[n]);
	pn.DeleteObject();
}
*/
//////////////////////////////
//----   Y=0 -----

if (!bIsProportional)
{
	m_dc->SelectObject(&penBLACK);
		ix0=r.left+(int)((-xMin)*cfx+disp.x);
		iy0=r.bottom-(int)((-yMin)*cfy-disp.y);

	m_dc->MoveTo(ix0,iy0);
		ix1=r.left+(int)((xMax-xMin)*cfx+disp.x);

	m_dc->LineTo(ix1,iy0);
}
//    X
	m_dc->SelectObject(penGRAY_LIGHT);
	m_dc->SetTextAlign(TA_CENTER);

	for (k=kx0; k<=kx1; k++)
	{
		ix0=r.left+(int)(( (ConstantX+nMinMeaningDigitX*pow((double)10., eX)+StepX*k*pow((double)10., eLinesX))*scaleLabelX-xMin)*cfx+disp.x);

		if (ix0>r.right) break;
		if (ix0>=r.left)
		{
			format(&str,ConstantX+nMinMeaningDigitX*pow((double)10., eX)+StepX*k*pow((double)10., eLinesX),chX,precisionX);
			m_dc->TextOut(ix0,r.bottom-25,str);
		}
	}

//    Y
	m_dc->SetTextAlign(TA_LEFT);

	for (k=ky0; k<=ky1; k++)
	{
		iy0=r.bottom-(int)(( (ConstantY+nMinMeaningDigitY*pow((double)10., eY)+StepY*k*pow((double)10., eLinesY))*scaleLabelY-yMin)*cfy-disp.y);

		if (iy0<r.top) break;
		if (iy0<=r.bottom)
		{
			format(&str,ConstantY+nMinMeaningDigitY*pow((double)10., eY)+StepY*k*pow((double)10., eLinesY),chY,precisionY);
			m_dc->TextOut(r.left+5,iy0-8,str);
		}
	}


// - - - - - - - - - - 
	m_dc->SelectObject(penBLACK);
	m_dc->TextOut(r.left+20,r.top+10,captionY);

	m_dc->SetTextAlign(TA_RIGHT);
	m_dc->TextOut(r.right-10,r.bottom-10,captionX);

// - - ( ) - - - - - - - - - - - - - - - - - - - - 
	m_dc->SetTextAlign(TA_RIGHT);

	iy0=r.bottom-25;
for (n=nArrays-1; n>=0; n--)
{
	str.Format(caption[n]);
	iy0-=20;
	ix0=r.right-10;

	m_dc->SelectObject(pen[n]);

	if (!bDrawPointsOnly[n])
	{
		m_dc->MoveTo(ix0,iy0);
		m_dc->LineTo(ix0-25,iy0);
	}
	else m_dc->Ellipse(ix0-5,iy0-5,ix0+5,iy0+5);


	ix0-=30;
	m_dc->TextOut(ix0,iy0-7,str);
}
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
//////////////////////////////
/*
if (bPaintCircles)
{
	CPen pn0,pn1;
	pn0.CreatePen(PS_SOLID,2,RGB(200,0,0));
	pn1.CreatePen(PS_SOLID,2,RGB(0,0,200));

iRad=5;

	m_dc->SelectObject(pn0);


	ix0=r.left+(int)(( aX0-xMin)*cfx+disp.x);
	iy0=r.bottom-(int)(( aY0-yMin)*cfy-disp.y);
	m_dc->Ellipse(ix0-iRad,iy0-iRad,ix0+iRad,iy0+iRad);


	m_dc->SelectObject(pn1);

	ix0=r.left+(int)(( aX1-xMin)*cfx+disp.x);
	iy0=r.bottom-(int)(( aY1-yMin)*cfy-disp.y);
	m_dc->Ellipse(ix0-iRad,iy0-iRad,ix0+iRad,iy0+iRad);


	pn0.DeleteObject();
	pn1.DeleteObject();
}
*/
//////////////////////////////

	m_dc->SelectObject(oldpen);

///	pn0.DeleteObject();
///	pn1.DeleteObject();


	SetCursor(AfxGetApp()->LoadStandardCursor(IDC_ARROW));
}
//---------------------------------------------------------------------------

void Chart::DefineMinMax()//  max  min   
{
	long i,k;

	if (nArrays<=0) 
	{
		bIsRangeDefined=FALSE;
		return;
	}
//	else if (!bIsRangeDefined)
	else
	{
		xMin=1.e308;
		yMin=1.e308;
		xMax=-1.e308;
		yMax=-1.e308;

		for (i=0; i<nArrays; i++)
		{
			if (!bDontDefineMinMax[i])
			{
				if (pX[i]==NULL)
				{
					if (xMin>(double)nMin[i]) xMin=(double)nMin[i];
					if (xMax<(double)nMax[i]) xMax=(double)nMax[i];
				}	
				else
				{
					for (k=nMin[i]; k<=nMax[i]; k++)
					{
						if (xMin>(*pX[i])[k]) xMin=(*pX[i])[k];
						if (xMax<(*pX[i])[k]) xMax=(*pX[i])[k];
					}
				}
				
				for (k=nMin[i]; k<=nMax[i]; k++)
				{
					if (yMin>(*pY[i])[k]) yMin=(*pY[i])[k];
					if (yMax<(*pY[i])[k]) yMax=(*pY[i])[k];
				}
			}
		}
		if (bPaintFromZero)
		{
			if (yMax<=0.)		yMax=0.;
			else if (yMin>=0.)	yMin=0.;
		}

		bIsRangeDefined=TRUE;
	}
}
//---------------------------------------------------------------------------

void Chart::AddArray(std::vector<double>* ptrX,
					 std::vector<double>* ptrY,
					 std::vector<BOOL>* ptrBool,// , /   
					 COLORREF color,
					 int thickness,
					 LPCTSTR cap,
					 BOOL b_Dont_Define_MinMax,
					 BOOL b_DrawPointsOnly)
{//    X  Y   
	if (((std::vector<double>*) ptrY)->size()>0)
	{
		nArrays++;
		if (nArrays>N_ARRAYS_MAX) 
		{
			CString s;
			s.Format("Chart::AddArray()\n      %i\n nArrays=%i",N_ARRAYS_MAX,nArrays);
			AfxMessageBox(s);
			return;
		}
		pX[nArrays-1]=ptrX;
		pY[nArrays-1]=ptrY;
		pBool[nArrays-1]=ptrBool;
		bDontDefineMinMax[nArrays-1]=b_Dont_Define_MinMax;
		bDrawPointsOnly[nArrays-1]=b_DrawPointsOnly;

		nMin[nArrays-1]=0;
		nMax[nArrays-1]=ptrY->size()-1;

		if (ptrX)
		if (nMax[nArrays-1]>ptrX->size()-1)
		{
			nMax[nArrays-1]=ptrX->size()-1;
	#ifdef _DEBUG
		AfxMessageBox("Chart::AddArray()\n   Y    X");
	#endif
		}

		pen[nArrays-1].CreatePen(PS_SOLID,thickness,color);
		caption[nArrays-1]=cap;
		
		if (!b_Dont_Define_MinMax)	DefineMinMax();
	}
	#ifdef _DEBUG
		else AfxMessageBox("Chart::AddArray()\n    Y");
	#endif
}
//---------------------------------------------------------------------------

void Chart::SetLabels(double scalX, double scalY,//       .
												 // ,       .
					  LPCTSTR capX, LPCTSTR capY)//   
{
	scaleLabelX=scalX;
	scaleLabelY=scalY;

	captionX=capX;
	captionY=capY;
}
//---------------------------------------------------------------------------

void Chart::SetProportional(BOOL bProp, BOOL bDifferent)
{
	bIsProportional=bProp;
	bAreDifferentXYScales=bDifferent;//       / 
}
//---------------------------------------------------------------------------

void Chart::SetYScale(double Yscale)
{
	yScale0=Yscale;
}
//---------------------------------------------------------------------------

void Chart::SetPaintFromZero()
{
	bPaintFromZero=TRUE;
}
//---------------------------------------------------------------------------

void Chart::SetPaintCircles()
{
	bPaintCircles=TRUE;
}
//---------------------------------------------------------------------------

void Chart::DontPaintNegatives()
{
	bDontPaintNegatives=TRUE;
}
//---------------------------------------------------------------------------

void Chart::SetMaxMinY(double max, double min)
{
	yMin=min;
	yMax=max;
}
//---------------------------------------------------------------------------

void Chart::me(double number, double* mantissa, double* exponent)
{//      number

	if (number==0.)
	{
		*mantissa=0.;
		*exponent=0.;
		return;
	}
	modf(log10(fabs(number)),exponent);
	*mantissa=number/pow((double)10.,*exponent);

	if (fabs(*mantissa)<1.) //      1<=|m|<10
	{
		*mantissa=(*mantissa)*10;
		*exponent=(*exponent)-1;
	}
}
//---------------------------------------------------------------------------

void Chart::format(CString* s, double num, char e, int precision)
{
//	     (%f  %e)     
//	(  %g   5        )

	if (num==0.) 
	{
		s->Format("0");
		return;
	}

	switch (e)
	{
	case 'f':
		{
			switch (precision)
			{
			case 0: { s->Format("%.0f",num); break; }
			case 1: { s->Format("%.1f",num); break; }
			case 2: { s->Format("%.2f",num); break; }
			case 3: { s->Format("%.3f",num); break; }
			case 4: { s->Format("%.4f",num); break; }
			case 5: { s->Format("%.5f",num); break; }
			case 6: { s->Format("%.6f",num); break; }
			case 7: { s->Format("%.7f",num); break; }
			case 8: { s->Format("%.8f",num); break; }
			case 9: { s->Format("%.9f",num); break; }
			case 10:{ s->Format("%.10f",num); break; };
			default: { s->Format("%g",num);}; 
			} break;
		}
	case 'e':
		{
			switch (precision)
			{
			case 0: { s->Format("%.0e",num); break; }
			case 1: { s->Format("%.1e",num); break; }
			case 2: { s->Format("%.2e",num); break; }
			case 3: { s->Format("%.3e",num); break; }
			case 4: { s->Format("%.4e",num); break; }
			case 5: { s->Format("%.5e",num); break; }
			case 6: { s->Format("%.6e",num); break; }
			case 7: { s->Format("%.7e",num); break; }
			case 8: { s->Format("%.8e",num); break; }
			case 9: { s->Format("%.9e",num); break; }
			case 10:;
			default:  s->Format("%.10e",num); 
			}
		}
	}
}
//---------------------------------------------------------------------------
/*
void Chart::SetSynArraysSizes()//  min  max ,    
{
	long min,max;

	bSynArraysSizes=TRUE;

	min=d->nFirstSynchronizedINSindex;
	max=d->nLastSynchronizedINSindex-d->nFirstSynchronizedINSindex;

	for (int i=0; i<nArrays; i++)
	{
		nMin[i]=min;
		nMax[i]=max;
	}
}
*/
//---------------------------------------------------------------------------

void Chart::SetArraysSizes()
{
//	if (bSynArraysSizes)	SetSynArraysSizes();//  min  max ,    
//	else
	for (int i=0; i<nArrays; i++)//  min  max ,    
	{
		nMin[i]=0;
		nMax[i]=((std::vector<double>*) pY[i])->size()-1;
	}
}
//---------------------------------------------------------------------------
/*
void Chart::OnScale(CRect r)
{ //  ,    r,   

	if (!bIsProportional)
	{
		CRect cr;
		GetClientRect(cr);

		cr.top+=nBorder;
		cr.bottom-=nBorder;
		cr.left+=nBorder;
		cr.right-=nBorder;

double	sx=(r.right-r.left)/(cr.right-cr.left);
		xScale=xScale*sx;
		disp.x=disp.x*sx+(sizeClient.cx-2*nBorder)*(1.0-sx)*0.5;

double	sy=(r.bottom-r.top)/(cr.bottom-cr.top);
		yScale=yScale*sy;
		disp.y=disp.y*sy+(sizeClient.cy-2*nBorder)*(sy-1.0)*0.5;

		OnButton();
	}
}
*/
//---------------------------------------------------------------------------
