#if !defined(AFX_CHART_H__C7296D22_4FB8_41BE_925D_CD049F3FBDB0__INCLUDED_)
#define AFX_CHART_H__C7296D22_4FB8_41BE_925D_CD049F3FBDB0__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// chart.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// Chart frame
#include "Data.h"

class Chart : public CMDIChildWnd
{
	DECLARE_DYNCREATE(Chart)
public:
	Chart(CHARTS n=e0, Data* p=NULL);
//	Chart();
	virtual ~Chart();

void OnButton();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(Chart)
	public:
	virtual BOOL Create(LPCTSTR szTitle, LONG style=0, const RECT& rect=rectDefault, CMDIFrameWnd* parent=NULL);
	protected:
	virtual BOOL OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext);
	//}}AFX_VIRTUAL

// Implementation
protected:
///	BOOL bSynArraysSizes;
	BOOL bAreDifferentXYScales;
//	void OnScale(CRect r);
	BOOL bNoScale;
	CPoint pointLButtonDown;
	void format(CString* s, double num, char e, int precision);
	void me(double number, double* mantissa, double* exponent);

	BOOL bDontPaintNegatives;
	BOOL bIsProportional;
	BOOL bPaintFromZero;
	BOOL bPaintCircles;
	BOOL bIsRangeDefined;
	CHARTS eChart;

	CDC m_dc;
	CRect rNew,rOld;
	CRect r;
	SIZE sizeDragRect; //  ( ?) -
	SIZE sOld;
//	POINT center;	//     
	struct{double x; double y;} disp; //    
	POINT dispBMP;	//  BMP      
	POINT click;// ,       / 
	POINT oldPoint;

	CBitmap bitmap;  // BMP   
	CBitmap *pOldBitmap;
	SIZE sizeClient; //    
	SIZE sizeDraw;   //    

	double yMax,yMin,xMax,xMin;

	double scaleLabelX, scaleLabelY;
	LPCTSTR captionX, captionY;
private:
	CString str;
	int nBorder;
	double Scale;
	double xCoeff,yCoeff, xScale,yScale, yScale0;

	CWnd* m_pParent;

	int nArrays;

	CPen pen[N_ARRAYS_MAX];
	LPCTSTR caption[N_ARRAYS_MAX];
	long nMin[N_ARRAYS_MAX];
	long nMax[N_ARRAYS_MAX];
	std::vector<double>* pX[N_ARRAYS_MAX];
	std::vector<double>* pY[N_ARRAYS_MAX];
	std::vector<BOOL>* pBool[N_ARRAYS_MAX];
	BOOL bDontDefineMinMax[N_ARRAYS_MAX];
	BOOL bDrawPointsOnly[N_ARRAYS_MAX];

	CPen penBLACK, penGRAY, penGRAY_LIGHT;
	CPen *oldpen;
	CBrush brushWHITE, brushYELLOW;

public:
	void SetArraysSizes();
//	void SetSynArraysSizes();

	Data* d;
	void SetMaxMinY(double max, double min);
	void DontPaintNegatives();
	void SetPaintFromZero();
	void SetPaintCircles();
	void SetYScale(double Yscale);
	void SetProportional(BOOL bProp, BOOL bDifferent=FALSE);

	void SetInitial();
	void PaintChart(CDC* m_dc);
	void DefineMinMax();

	void AddArray(std::vector<double>* ptrX,
				  std::vector<double>* ptrY,
				  std::vector<BOOL>* ptrBool,
				  COLORREF color,
				  int thickness,
				  LPCTSTR cap="",
				  BOOL b_Dont_Define_MinMax=FALSE,
				  BOOL b_DrawPointsOnly=FALSE);

	void SetLabels(double scalX, double scalY, LPCTSTR capX="", LPCTSTR capY="");

	// Generated message map functions
	//{{AFX_MSG(Chart)
	afx_msg void OnPaint();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnButtonPlus();
	afx_msg void OnButtonMinus();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnButtonZeroPos();
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnButtonPlusX();
	afx_msg void OnButtonMinusX();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CHART_H__C7296D22_4FB8_41BE_925D_CD049F3FBDB0__INCLUDED_)
